/*
 * Copyright (c) 2005-2013 Dirk Aporius <dirk.aporius@gmail.com>
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.apogames.help;

/**
 * eine einfache Klasse, die einen Punkt darstellt,
 * aber nicht wie bei der Original Point Klasse mit int Werten,
 * sondern mit float Werten fr x und y
 * @author Dirk Aporius
 */
public class ApoFloatPoint
{
	/**
	 * X-Wert des Punktes
	 */
	public float x;
	/**
	 * X-Wert des Punktes
	 */
	public float y;
	
	/**
	 * ein ApoFloatPoint Objekt wird erzeigt
	 * @param x: X-Wert des Punktes
	 * @param y: Y-Wert des Punktes
	 */
	public ApoFloatPoint( float x, float y ) {
		this.x	= x;
		this.y	= y;
	}

	/**
	 * gibt den X-Wert des Punktes zurck
	 * @return gibt den X-Wert des Punktes zurck
	 */
	public float getX() {
		return x;
	}

	/**
	 * setzt den x-Wert des Punktes auf den bergebenen Wert
	 * @param x = setzt den x-Wert des Punktes auf den bergebenen Wert
	 */
	public void setX(float x) {
		this.x = x;
	}

	/**
	 * gibt den y-Wert des Punktes zurck
	 * @return gibt den y-Wert des Punktes zurck
	 */
	public float getY() {
		return y;
	}

	/**
	 * setzt den y-Wert des Punktes auf den bergebenen Wert
	 * @param y = setzt den y-Wert des Punktes auf den bergebenen Wert
	 */
	public void setY(float y) {
		this.y = y;
	}
	
	

}
