/*
 * Copyright (c) 2005-2013 Dirk Aporius <dirk.aporius@gmail.com>
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.apogames.help;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;

import org.apogames.ApoConstants;

public class ApoGameCounter {

	private static ApoGameCounter singleInstance = new ApoGameCounter();

	public static ApoGameCounter getInstance() {
		if (null == singleInstance) {
			singleInstance = new ApoGameCounter();
		}
		return singleInstance;
	}
	
	@SuppressWarnings("deprecation")
	public boolean save(final String value) {
		if (ApoConstants.B_ONLINE) {
			Thread t = new Thread(new Runnable() {
				@Override
				public void run() {
					try {
						URL url;
						URLConnection urlConn;
						DataOutputStream printout;
						DataInputStream input;
		
						url = new URL("http://www.apo-games.de/apoSheeptastic/game_counter.php");
						urlConn = url.openConnection();
		
						urlConn.setDoInput(true);
						urlConn.setDoOutput(true);
		
						urlConn.setUseCaches(false);
						urlConn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
		
						printout = new DataOutputStream(urlConn.getOutputStream());
						
						String content = "value=" + URLEncoder.encode(String.valueOf(value), "UTF-8");
						printout.writeBytes(content);
						printout.flush();
						printout.close();
		
						input = new DataInputStream(urlConn.getInputStream());
						@SuppressWarnings("unused")
						String str;
						while (null != ((str = input.readLine()))) {
						}
						input.close();
					} catch (MalformedURLException me) {
						System.err.println("MalformedURLException: " + me);
					} catch (IOException ioe) {
						System.err.println("IOException: " + ioe.getMessage());
					}
				}
			});
			t.start();
		}
		return false;
	}
	
}
